package cz.upol.jj2.lecture06;

import java.awt.*;
import java.awt.event.ActionEvent;

import javax.swing.*;

public class ListExample extends JFrame {

	private JList<String> mainList;
	private JButton btnAdd;
	private JPanel mainPanel;
	private DefaultListModel<String> listModel;

	public ListExample() {
		super();

		// seznam zpracovavajici data z nejakoho modelu.

		//nejprve model (vychozi model je seznam implementovany arraylistem)
		listModel = new DefaultListModel<String>();
		listModel.addElement("Foo");
		//nad nim seznam
		mainList = new JList<>(listModel);


		btnAdd = new JButton("add");
		btnAdd.addActionListener(this::addAction);

		mainPanel = new JPanel(new BorderLayout());
		mainPanel.add(mainList, BorderLayout.CENTER);
		mainPanel.add(btnAdd, BorderLayout.SOUTH);

		this.setContentPane(mainPanel);
		this.setTitle("Lists & Dialogs");
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setPreferredSize(new Dimension(400, 400));

		this.pack();
	}

	/**
	 * Zobrazeni dialogu pro novy radek
	 */
	private void addAction(ActionEvent e) {
		AddDialog dlg = new AddDialog(this);
		dlg.setModal(true);
		dlg.setVisible(true);
		//zmena v modelu se projevi v seznamu
		if (dlg.getResult() != null)
			listModel.addElement(dlg.getResult());


		dlg.dispose();
	}

private class AddDialog extends JDialog {
	private JButton butOK;
	private JButton butCancel;

	private TextField txtField;

	private JLabel lblText;
	private JPanel mainPanel;

	private String result;

	public AddDialog(JFrame parrent){
		super(parrent);
		this.butOK = new JButton("OK");
		this.butCancel = new JButton("Cancel");
		this.butCancel.addActionListener(this::cancelClick);

		this.butOK.addActionListener(this::okClick);
		this.txtField = new TextField();
		this.lblText = new JLabel("Text:");

		this.mainPanel = new JPanel();
		GridLayout gl = new GridLayout(2,2);
		this.mainPanel.setLayout(gl);
		this.mainPanel.add(lblText);
		this.mainPanel.add(txtField);
		this.mainPanel.add(butCancel);
		this.mainPanel.add(butOK);

		this.setPreferredSize(new Dimension(200, 75));
		this.setContentPane(mainPanel);
		this.pack();
	}

	private void okClick(ActionEvent e){
		this.result = txtField.getText();
		this.setVisible(false);
	}

	private void cancelClick(ActionEvent e){
		this.result = null;
		this.setVisible(false);
	}

	public String getResult(){
		return result;
	}
}
}